blob: 29a51e68738f664119760750a811da8e536e393b [file] [log] [blame]
Holger Hans Peter Freyther4edd6e62013-04-10 18:34:58 +02001#!/bin/sh
2### BEGIN INIT INFO
3# Provides: osmo-pcap-client
4# Required-Start: $network $local_fs
5# Required-Stop:
6# Default-Start: 2 3 4 5
7# Default-Stop: 0 1 6
8# Short-Description: Start the pcap client
9# Description: PCAP Client for the PCAP aggregation
10### END INIT INFO
11
12# Author: Holger Hans Peter Freyther <holger@freyther.de>
13
14# PATH should only include /usr/* if it runs after the mountnfs.sh script
15PATH=/sbin:/usr/sbin:/bin:/usr/bin
16DESC=osmo-pcap-client # Introduce a short description here
17NAME=osmo-pcap-client # Introduce the short server's name here
18DAEMON=/usr/bin/osmo_pcap_client # Introduce the server's location here
19DAEMON_ARGS="-c /etc/osmo-pcap/osmo-pcap-client.cfg" # Arguments to run the daemon with
20PIDFILE=/var/run/$NAME.pid
21SCRIPTNAME=/etc/init.d/$NAME
22
23# Exit if the package is not installed
24[ -x $DAEMON ] || exit 0
25
26# Read configuration variable file if it is present
27[ -r /etc/default/$NAME ] && . /etc/default/$NAME
28
29# Load the VERBOSE setting and other rcS variables
30. /lib/init/vars.sh
31
32# Define LSB log_* functions.
33# Depend on lsb-base (>= 3.0-6) to ensure that this file is present.
34. /lib/lsb/init-functions
35
36#
37# Function that starts the daemon/service
38#
39do_start()
40{
41 # Return
42 # 0 if daemon has been started
43 # 1 if daemon was already running
44 # 2 if daemon could not be started
45 start-stop-daemon --start --quiet --pidfile $PIDFILE --exec $DAEMON --test > /dev/null \
46 || return 1
47 start-stop-daemon -b -m --start --quiet --pidfile $PIDFILE --exec $DAEMON -- \
48 $DAEMON_ARGS \
49 || return 2
50 # Add code here, if necessary, that waits for the process to be ready
51 # to handle requests from services started subsequently which depend
52 # on this one. As a last resort, sleep for some time.
53}
54
55#
56# Function that stops the daemon/service
57#
58do_stop()
59{
60 # Return
61 # 0 if daemon has been stopped
62 # 1 if daemon was already stopped
63 # 2 if daemon could not be stopped
64 # other if a failure occurred
65 start-stop-daemon --stop --quiet --retry=TERM/30/KILL/5 --pidfile $PIDFILE
66 RETVAL="$?"
67 [ "$RETVAL" = 2 ] && return 2
68 # Wait for children to finish too if this is a daemon that forks
69 # and if the daemon is only ever run from this initscript.
70 # If the above conditions are not satisfied then add some other code
71 # that waits for the process to drop all resources that could be
72 # needed by services started subsequently. A last resort is to
73 # sleep for some time.
74 #start-stop-daemon --stop --quiet --oknodo --retry=0/30/KILL/5 --exec $DAEMON
75 #[ "$?" = 2 ] && return 2
76 # Many daemons don't delete their pidfiles when they exit.
77 rm -f $PIDFILE
78 return "$RETVAL"
79}
80
81#
82# Function that sends a SIGHUP to the daemon/service
83#
84do_reload() {
85 #
86 # If the daemon can reload its configuration without
87 # restarting (for example, when it is sent a SIGHUP),
88 # then implement that here.
89 #
90 start-stop-daemon --stop --signal 1 --quiet --pidfile $PIDFILE --name $NAME
91 return 0
92}
93
94case "$1" in
95 start)
96 [ "$VERBOSE" != no ] && log_daemon_msg "Starting $DESC " "$NAME"
97 do_start
98 case "$?" in
99 0|1) [ "$VERBOSE" != no ] && log_end_msg 0 ;;
100 2) [ "$VERBOSE" != no ] && log_end_msg 1 ;;
101 esac
102 ;;
103 stop)
104 [ "$VERBOSE" != no ] && log_daemon_msg "Stopping $DESC" "$NAME"
105 do_stop
106 case "$?" in
107 0|1) [ "$VERBOSE" != no ] && log_end_msg 0 ;;
108 2) [ "$VERBOSE" != no ] && log_end_msg 1 ;;
109 esac
110 ;;
111 status)
112 status_of_proc "$DAEMON" "$NAME" && exit 0 || exit $?
113 ;;
114 #reload|force-reload)
115 #
116 # If do_reload() is not implemented then leave this commented out
117 # and leave 'force-reload' as an alias for 'restart'.
118 #
119 #log_daemon_msg "Reloading $DESC" "$NAME"
120 #do_reload
121 #log_end_msg $?
122 #;;
123 restart|force-reload)
124 #
125 # If the "reload" option is implemented then remove the
126 # 'force-reload' alias
127 #
128 log_daemon_msg "Restarting $DESC" "$NAME"
129 do_stop
130 case "$?" in
131 0|1)
132 do_start
133 case "$?" in
134 0) log_end_msg 0 ;;
135 1) log_end_msg 1 ;; # Old process is still running
136 *) log_end_msg 1 ;; # Failed to start
137 esac
138 ;;
139 *)
140 # Failed to stop
141 log_end_msg 1
142 ;;
143 esac
144 ;;
145 *)
146 #echo "Usage: $SCRIPTNAME {start|stop|restart|reload|force-reload}" >&2
147 echo "Usage: $SCRIPTNAME {start|stop|status|restart|force-reload}" >&2
148 exit 3
149 ;;
150esac
151
152: